> ## Documentation Index
> Fetch the complete documentation index at: https://sendforsign.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Place special placeholder

> Place special placeholders in a PDF contract via the Sendforsign API: each recipient's signature, full name, email and date signed.

Special placeholders are four types of placeholders that are created automatically for every recipient.
So, before placing special fields in your PDF contract, create a recipient using [this request](https://sendforsign.com/docs/api-reference/recipient/create.md).
After this, all the special placeholders will be created automatically with corresponding keys:
`Recipient_Key_1`, `Recipient_Key_2`, `Recipient_Key_3`, `Recipient_Key_4`.

Here's an example of a placeholder key: `"placeholderKey": "93447fb5-91ee-41ad-9f73-b4ae2d467292_4"`.

Available placeholder codes:

* **1**: Recipient's date signed.
* **2**: Recipient's full name.
* **3**: Recipient's email.
* **4**: Recipient's signature.

### Body parameters

**data** `object` *required*

**child attribute**

**action** `string` *required*

Action type.

**clientKey** `string` *required*

Key of the client.

**contractKey** `string` *required*

Key of the contract.

**placeholders** `array` *required*

Array of placeholders.

**child attribute**

**placeholderKey** `string` *required*

Key of the placeholder that needs to be updated. Generated automatically from 2 paramaters: Recipient's Key and Special Type.

**isSpecial** `boolean` *required*

True for special fields.

**specialType** `string` *required*

Use the following placeholder codes to create the corresponding fields:
**1**: Recipient's date signed,
**2**: Recipient's full name
**3**: Recipient's email
**4**: Recipient's signature

**insertion** `array`

Array of places.

**child attribute**

**id** `string`

ID of the insertion. Provide a new ID for each insertion. If you provide the ID of an existing
placeholder, the placeholder will be updated.

**pageId** `string`

Page number where you insert the placeholder, starting from 0.

**width** `string`

Width of the placeholder.

**height** `string`

Height of the placeholder.

**positionX** `string`

Position X of the placeholder, starting from the top-left corner of the page.

**positionY** `string`

Position Y of the placeholder, starting from the top-left corner of the page.

### Response

**placeholder** `string`

Placeholder structure.

**child attribute**

**createTime** `string`

Create time.

**changeTime** `string`

Change time.

**code** `string`

The code of the answer.

**message** `string`

The message of the answer.

```bash cURL theme={null}
curl -X POST 'https://api.sendforsign.com/api/placeholder' \
     -H 'X-Sendforsign-Key: YOUR_API_KEY' \
     -H 'Content-Type: application/json' \
     -d '{
    "data": {
        "action": "update",
        "clientKey": "YOUR_CLIENT_KEY",
        "contractKey": "CONTRACT_KEY",
        "placeholders": [
            {
                "placeholderKey": "RECIPIENT_KEY_4",
                "isSpecial": true,
                "specialType": 4,
                "insertion": [
                    {
                        "action": "update",
                        "clientKey": "YOUR_CLIENT_KEY",
                        "id": 2,
                        "pageId": 0,
                        "width": 150,
                        "height": 150,
                        "positionX": 1,
                        "positionY": 1
                    }
                ]
            }
        ]
    }
}'
```

```json Response theme={null}
{
    "code": 201,
    "message": "Placeholder updated"
}
```


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.